package org.springblade.flow.datalog.params;

import java.util.List;


import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 数据导出请求参数实体类
 * 
 * @author William
 * @date 2022年12月2日 上午10:26:28
 */
@Data
public class DataExportParam {
	@ApiModelProperty(value = "表单ID", required = true)
	private String modelId;

	@ApiModelProperty(value = "任务名称", name = "taskName", required = true)
	private String taskName;

	@ApiModelProperty(value = "是否导出所有数据(true-全部，false=非全部)", required = true)
	private boolean isAll;
	
	@ApiModelProperty(value = "要导出字段在数据集中的ID数组", required = true)
	private List<Integer> columnIdList;

	@ApiModelProperty(value = "要导出的数据ID数组，isAll=true时必传", required = false)
	private List<String> dataIdList;

}
