package org.springblade.flow.engine.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 流程传阅
 *
 * @author JNPF开发平台组
 * @version V3.1.0
 * @copyright 引迈信息技术有限公司
 * @date 2019年9月27日 上午9:18
 */
@Data
@TableName("flow_taskcirculate")
public class FlowTaskCirculateEntity {
    /**
     * 传阅主键
     */
    @TableId("F_ID")
    private String id;

    /**
     * 对象类型
     */
    @TableField("F_OBJECTTYPE")
    private String objectType;

    /**
     * 对象主键
     */
    @TableField("F_OBJECTID")
    private String objectId;

    /**
     * 节点编码
     */
    @TableField("F_NODECODE")
    private String nodeCode;

    /**
     * 节点名称
     */
    @TableField("F_NODENAME")
    private String nodeName;

    /**
     * 节点主键
     */
    @TableField("F_TASKNODEID")
    private String taskNodeId;

    /**
     * 任务主键
     */
    @TableField("F_TASKID")
    private String taskId;

    /**
     * 创建时间
     */
    @TableField(value = "F_CREATORTIME",fill = FieldFill.INSERT)
    private Date creatorTime;


    /**
     * billCode应该是
     */
    @TableField(value = "F_EnCode")
    private String enCode;
    @TableField(value = "F_FullName")
    private String fullName;
    /**
     * 所属流程
     */
    @TableField(value = "F_FlowId")
    private String flowId;
    /**
     * 所属分类
     */
    @TableField(value = "F_FlowCategory")
    private String flowCategory;
    @TableField(value = "F_UpdateTime")
    private Date updateTime;
    @TableField(value = "F_CreateUserId")
    private String createUserId;
}
